<?php

namespace App\idms\Controllers;

if (!defined('C8L6K7E')) {
    header("Location: /");
    die("Erro: Página não encontrada<br>");
}

/**
 * Controller cadastrar cores
 * @author Cesar <cesar@celke.com.br>
 */
class AddDriveComp
{

    /** @var array|string|null $data Recebe os dados que devem ser enviados para VIEW */
    private array|string|null $data = [];

    /** @var array $dataForm Recebe os dados do formulario */
    private array|null $dataForm;

    /**     
     * Método cadastrar cor
     * Receber os dados do formulário.
     * Quando o usuário clicar no botão "cadastrar" do formulário da página nova cor. Acessa o IF e instância a classe "AdmsAddColores" responsável em cadastrar a situação no banco de dados.
     * Situação cadastrada com sucesso, redireciona para a página listar registros.
     * Senão, instância a classe responsável em carregar a View e enviar os dados para View.
     * 
     * @return void
     */
    public function index(): void
    {
        $this->dataForm = filter_input_array(INPUT_POST, FILTER_DEFAULT);

        if (!empty($this->dataForm['SendAddDriveComp'])) {
            unset($this->dataForm['SendAddDriveComp']);
            $createDriveComp = new \App\idms\Models\IdmsAddDriveComp();
            $createDriveComp->create($this->dataForm);
            if ($createDriveComp->getResult()) {
                $urlRedirect = URLADM . "list-drive-comp/index";
                header("Location: $urlRedirect");
            } else {
                $this->data['form'] = $this->dataForm;
                $this->viewAddDriveComp();
            }
        } else {
            $this->viewAddDriveComp();
        }
    }

    /**
     * Instanciar a classe responsável em carregar a View e enviar os dados para View.
     * 
     */
    private function viewAddDriveComp(): void
    {
        $button = ['list_drive_comp' => ['menu_controller' => 'list-drive-comp', 'menu_metodo' => 'index']];
        $listBotton = new \App\adms\Models\helper\AdmsButton();
        $this->data['button'] = $listBotton->buttonPermission($button);

        $listMenu = new \App\adms\Models\helper\AdmsMenu();
        $this->data['menu'] = $listMenu->itemMenu(); 
        
        $this->data['sidebarActive'] = "list-drive-comp"; 
        
        $loadView = new \Core\ConfigView("idms/Views/driveComp/addDriveComp", $this->data);
        $loadView->loadView();
    }
}
