<?php

namespace App\idms\Controllers;

if(!defined('C8L6K7E')){
    header("Location: /");
    die("Erro: Página não encontrada<br>");
}

/**
 * Controller apagar email delegado
 * @author Cesar <cesar@celke.com.br>
 */
class DeleteEmailDelega
{

    /** @var int|string|null $id Recebe o id do registro */
    private int|string|null $id;
    
    /**
     * Método apagar email delegado
     * Se existir o ID na URL instancia a MODELS para excluir o registro no banco de dados
     * Senão criar a mensagem de erro
     * Redireciona para a página listar email delegado
     *
     * @param integer|string|null|null $id Receber o id do registro que deve ser excluido
     * @return void
     */
    public function index(int|string|null $id = null): void
    {

        if (!empty($id)) {
            $this->id = (int) $id;
            $deleteEmailDelega = new \App\idms\Models\IdmsDeleteEmailDelega();
            $deleteEmailDelega->deleteEmailDelega($this->id);            
        } else {
            $_SESSION['msg'] = "<p class='alert-danger'>Erro: Necessário selecionar um Email!</p>";
        }

        $urlRedirect = URLADM . "list-delega-email/index";
        header("Location: $urlRedirect");

    }
}
