<?php

namespace App\adms\Controllers;

if (!defined('C8L6K7E')) {
    header("Location: /");
    die("Erro: Página não encontrada<br>");
}

/**
 * Controller editar cor
 * @author Cesar <cesar@celke.com.br>
 */
class EditEmailDelega
{

    /** @var array|string|null $data Recebe os dados que devem ser enviados para VIEW */
    private array|string|null $data = [];

    /** @var array $dataForm Recebe os dados do formulario */
    private array|null $dataForm;

    /** @var int|string|null $id Recebe o id do registro */
    private int|string|null $id;

    /**
     * Método editar cor.
     * Receber os dados do formulário.
     * 
     * Se o parâmetro ID e diferente de vazio e o usuário não clicou no botão editar, instancia a MODELS para recuperar as informações da cor no banco de dados, se encontrar instancia o método "viewEditColor". Se não existir redireciona para o listar cor.
     * 
     * Se não existir o usuário clicar no botão acessa o ELSE e instancia o método "editColor".
     * 
     * @return void
     */
    public function index(int|string|null $id = null): void
    {
        $this->dataForm = filter_input_array(INPUT_POST, FILTER_DEFAULT);

        if ((!empty($id)) and (empty($this->dataForm['SendEditEmailDelega']))) {
            $this->id = (int) $id;
            $viewEmailDelega = new \App\idms\Models\IdmsEditEmailDelega();
            $viewEmailDelega->viewEmailDelega($this->id);
            if ($viewEmailDelega->getResult()) {
                $this->data['form'] = $viewEmailDelega->getResultBd();
                $this->viewEditEmailDelega();
            } else {
                $urlRedirect = URLADM . "list-email-delega/index";
                header("Location: $urlRedirect");
            }
        } else {
            $this->editEmailDelega();
        }
    }

    /**
     * Instanciar a classe responsável em carregar a View e enviar os dados para View.
     * 
     */
    private function viewEditEmailDelega(): void
    {
        $button = ['list_email_delega' => ['menu_controller' => 'list-email-delega', 'menu_metodo' => 'index'],
        'view_email_delega' => ['menu_controller' => 'view-email-delega', 'menu_metodo' => 'index']];
        $listBotton = new \App\adms\Models\helper\AdmsButton();
        $this->data['button'] = $listBotton->buttonPermission($button);
        
        $listMenu = new \App\adms\Models\helper\AdmsMenu();
        $this->data['menu'] = $listMenu->itemMenu(); 
        
        $this->data['sidebarActive'] = "list-email-delega"; 
        $loadView = new \Core\ConfigView("idms/Views/emailDelega/editEmailDelega", $this->data);
        $loadView->loadView();
    }

    /**
     * Editar cor.
     * Se o usuário clicou no botão, instancia a MODELS responsável em receber os dados e editar no banco de dados.
     * Verifica se editou corretamente a cor no banco de dados.
     * Se o usuário não clicou no botão redireciona para página listar cor.
     *
     * @return void
     */
    private function editEmailDelega(): void
    {
        if (!empty($this->dataForm['SendEditEmailDelega'])) {
            unset($this->dataForm['SendEditEmailDelega']);
            $editEmailDelega = new \App\idms\Models\IdmsEditEmailDelega();
            $editEmailDelega->update($this->dataForm);
            if ($editEmailDelega->getResult()) {
                $urlRedirect = URLADM . "view-email-delega/index/" . $this->dataForm['id'];
                header("Location: $urlRedirect");
            } else {
                $this->data['form'] = $this->dataForm;
                $this->viewEditEmailDelega();
            }
        } else {
            $_SESSION['msg'] = "<p class='alert-danger'>Erro: Email não encontrada!</p>";
            $urlRedirect = URLADM . "list-email-delega/index";
            header("Location: $urlRedirect");
        }
    }
}
