<?php

namespace App\idms\Controllers;

if(!defined('C8L6K7E')){
    header("Location: /");
    die("Erro: Página não encontrada<br>");
}

/**
 * Controller da página visualizar a configuração de dominio
 * @author Cesar <cesar@celke.com.br>
 */
class ViewConfigDominio
{
    /** @var array|string|null $data Recebe os dados que devem ser enviados para VIEW */
    private array|string|null $data;

    /** @var int|string|null $id Recebe o id do registro */
    private int|string|null $id;

    /**
     * Metodo visualizar a configuração de dominio
     * Recebe como parametro o ID que será usado para pesquisar as informações no banco de dados e instancia a MODELS IdmsViewConfigDominio
     * Se encontrar registro no banco de dados envia para VIEW.
     * Senão é redirecionado para o listar configuração de dominio.
     * 
     * @return void
     */
    public function index(int|string|null $id = null): void
    {
        if (!empty($id)) {
            $this->id = (int) $id;

            $viewConfigDominio = new \App\idms\Models\IdmsViewConfigDominio();
            $viewConfigDominio->viewConfigDominio($this->id);
            if ($viewConfigDominio->getResult()) {
                $this->data['viewConfigDominio'] = $viewConfigDominio->getResultBd();
                $this->viewConfigDominio();
            } else {
                $urlRedirect = URLADM . "list-config-dominio/index";
                header("Location: $urlRedirect");
            }
        } else {
            $_SESSION['msg'] = "<p class='alert-danger'>Erro: Usuário não encontrado!</p>";
            $urlRedirect = URLADM . "list-config-dominio/index";
            header("Location: $urlRedirect");
        }
    }

    /**
     * Instanciar a classe responsável em carregar a View e enviar os dados para View.
     * 
     */
    private function viewConfigDominio(): void
    {
        $button = ['list_config_dominio' => ['menu_controller' => 'list-config-dominio', 'menu_metodo' => 'index'],
        'edit_config_dominio' => ['menu_controller' => 'edit-confi-dominio', 'menu_metodo' => 'index'],
        'delete_config_dominio' => ['menu_controller' => 'delete-config-dominio', 'menu_metodo' => 'index']];
        $listBotton = new \App\adms\Models\helper\AdmsButton();
        $this->data['button'] = $listBotton->buttonPermission($button);

        $listMenu = new \App\adms\Models\helper\AdmsMenu();
        $this->data['menu'] = $listMenu->itemMenu(); 
        
        $this->data['sidebarActive'] = "list-config-dominio"; 
        $loadView = new \Core\ConfigView("idms/Views/configDominio/viewConfigDominio", $this->data);
        $loadView->loadView();
    }
}
