<?php

namespace App\idms\Controllers;

if(!defined('C8L6K7E')){
    header("Location: /");
    die("Erro: Página não encontrada<br>");
}

/**
 * Controller da página visualizar a configuração de dominio
 * @author Cesar <cesar@celke.com.br>
 */
class ViewEmailDelega
{
    /** @var array|string|null $data Recebe os dados que devem ser enviados para VIEW */
    private array|string|null $data;

    /** @var int|string|null $id Recebe o id do registro */
    private int|string|null $id;

    /**
     * Metodo visualizar a configuração de dominio
     * Recebe como parametro o ID que será usado para pesquisar as informações no banco de dados e instancia a MODELS IdmsViewConfigDominio
     * Se encontrar registro no banco de dados envia para VIEW.
     * Senão é redirecionado para o listar configuração de dominio.
     * 
     * @return void
     */
    public function index(int|string|null $id = null): void
    {
        if (!empty($id)) {
            $this->id = (int) $id;

            $viewEmailDelega = new \App\idms\Models\IdmsViewEmailDelega();
            $viewEmailDelega->viewEmailDelega($this->id);
            if ($viewEmailDelega->getResult()) {
                $this->data['viewEmailDelega'] = $viewEmailDelega->getResultBd();
                $this->viewDriveComp();
            } else {
                $urlRedirect = URLADM . "list-email-delega/index";
                header("Location: $urlRedirect");
            }
        } else {
            $_SESSION['msg'] = "<p class='alert-danger'>Erro: Usuário não encontrado!</p>";
            $urlRedirect = URLADM . "list-email-delega/index";
            header("Location: $urlRedirect");
        }
    }

    /**
     * Instanciar a classe responsável em carregar a View e enviar os dados para View.
     * 
     */
    private function viewEmailDelega(): void
    {
        $button = ['list_email_delega' => ['menu_controller' => 'list-email-delega', 'menu_metodo' => 'index'],
        'edit_email_delega' => ['menu_controller' => 'edit-email-delega', 'menu_metodo' => 'index'],
        'delete_email_delega' => ['menu_controller' => 'delete-email-delega', 'menu_metodo' => 'index']];
        $listBotton = new \App\adms\Models\helper\AdmsButton();
        $this->data['button'] = $listBotton->buttonPermission($button);

        $listMenu = new \App\adms\Models\helper\AdmsMenu();
        $this->data['menu'] = $listMenu->itemMenu(); 
        
        $this->data['sidebarActive'] = "list-email-delega"; 
        $loadView = new \Core\ConfigView("idms/Views/emailDelega/viewEmailDelega", $this->data);
        $loadView->loadView();
    }
}
