<?php

namespace App\idms\Models;

if (!defined('C8L6K7E')) {
    header("Location: /");
    die("Erro: Página não encontrada<br>");
}

/**
 * Apagar drive no banco de dados
 *
 * @author Celke
 */
class IdmsDeleteDriveComp
{

    /** @var bool $result Recebe true quando executar o processo com sucesso e false quando houver erro */
    private bool $result = false;

    /** @var int|string|null $id Recebe o id do registro */
    private int|string|null $id;

    /** @var array|null $resultBd Recebe os registros do banco de dados */
    private array|null $resultBd;

    /**
     * @return bool Retorna true quando executar o processo com sucesso e false quando houver erro
     */
    function getResult(): bool
    {
        return $this->result;
    }

    /**
     * Metodo recebe como parametro o ID do registro que será excluido
     * Chama as funções viewSit e checkColorUsed para fazer a confirmação do registro antes de excluir
     * @param integer $id
     * @return void
     */
    public function deleteDriveComp(int $id): void
    {
        $this->id = (int) $id;

        if (($this->viewDriveComp()) and ($this->checkDriveCompUsed())) {
            $deleteDriveComp = new \App\adms\Models\helper\AdmsDelete();
            $deleteDriveComp->exeDelete("idms_drive_comp", "WHERE id =:id", "id={$this->id}");

            if ($deleteDriveComp->getResult()) {
                $_SESSION['msg'] = "<p class='alert-success'>Drive apagado com sucesso!</p>";
                $this->result = true;
            } else {
                $_SESSION['msg'] = "<p class='alert-danger'>Erro: Drive não apagado com sucesso!</p>";
                $this->result = false;
            }
        } else {
            $this->result = false;
        }
    }

    /**
     * Metodo verifica se o drive esta cadastrado na tabela e envia o resultado para a função deleteDriveComp
     * @return boolean
     */
    private function viewDriveComp(): bool
    {

        $viewDriveComp = new \App\adms\Models\helper\AdmsRead();
        $viewDriveComp->fullRead(
            "SELECT id
                            FROM idms_drive_comp                           
                            WHERE id=:id
                            LIMIT :limit",
            "id={$this->id}&limit=1"
        );

        $this->resultBd = $viewDriveComp->getResult();
        if ($this->resultBd) {
            return true;
        } else {
            $_SESSION['msg'] = "<p class='alert-danger'>Erro: Drive não encontrado!</p>";
            return false;
        }
    }

  
    }
}
