<?php

namespace App\idms\Models;

if (!defined('C8L6K7E')) {
    header("Location: /");
    die("Erro: Página não encontrada<br>");
}

/**
 * Visualizar a configuração no banco de dados
 *
 * @author Celke
 */
class IdmsViewConfigDominio
{

    /** @var bool $result Recebe true quando executar o processo com sucesso e false quando houver erro */
    private bool $result = false;

    /** @var array|null $resultBd Recebe os registros do banco de dados */
    private array|null $resultBd;

    /** @var int|string|null $id Recebe o id do registro */
    private int|string|null $id;

    /**
     * @return bool Retorna true quando executar o processo com sucesso e false quando houver erro
     */
    function getResult(): bool
    {
        return $this->result;
    }

    /**
     * @return bool Retorna os detalhes do registro
     */
    function getResultBd(): array|null
    {
        return $this->resultBd;
    }

    /**
     * Metodo para visualizar os detalhes do dominio
     * Recebe o ID do usuário que será usado como parametro na pesquisa
     * Retorna FALSE se houver algum erro
     * @param integer $id
     * @return void
     */
    public function viewConfigDominio(int $id): void
    {
        $this->id = $id;

        $viewConfigDominio = new \App\adms\Models\helper\AdmsRead();
        $viewConfigDominio->fullRead("SELECT id, name, number, url, created, modified
                    FROM idms_config_dominio 
                    WHERE id=:id
                    LIMIT :limit", "id={$this->id}&limit=1");

        $this->resultBd = $viewConfigDominio->getResult();        
        if ($this->resultBd) {
            $this->result = true;
        } else {
            $_SESSION['msg'] = "<p class='alert-danger'>Erro: E-mail não encontrado!</p>";
            $this->result = false;
        }
    }
}
